Index: trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90	(revision 2542)
@@ -471,534 +524,203 @@
 !----------------------------------------------------------------------
 
-      nb_phot       = 11       ! jmars.20140930 reduit de 13 a 11
+      nb_phot       = nb_phot_hv_max
       nb_reaction_3 = 0
       nb_reaction_4 = 0
 
+      nb_hv         = 0
+      nb_pfunc1     = 0
+      nb_pfunc2     = 0
+      nb_pfunc3     = 0
+
 !----------------------------------------------------------------------
-!     oxygen reactions 
+!     reactions 
 !----------------------------------------------------------------------
 
-!---  a001: o + o2 + co2 -> o3 + co2
-
-!     jpl 2003
-!
-!     co2 efficiency as a third body (2.075)
-!     from sehested et al., j. geophys. res., 100, 1995.
-
-      a001(:) = 2.075*6.0e-34*(t(:)/300.)**(-2.4)*dens(:)
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = a001(:)
-
-!---  a002: o + o + co2 -> o2 + co2
-
-!     Tsang and Hampson, J. Chem. Phys. Ref. Data, 15, 1087, 1986
-
-!     a002(:) = 2.5*5.2e-35*exp(900./t(:))*dens(:)
-
-!     Campbell and Gray, Chem. Phys. Lett., 18, 607, 1973
-
-!     a002(:) = 1.2e-32*(300./t(:))**(2.0)*dens(:)  ! yung expression
-      a002(:) = 2.5*9.46e-34*exp(485./t(:))*dens(:) ! nist expression
-
-      nb_reaction_3 = nb_reaction_3 + 1
-      v_3(:,nb_reaction_3) = a002(:)
-
-!---  a003: o + o3 -> o2 + o2
-
-!     jpl 2003
-
-      a003(:) = 8.0e-12*exp(-2060./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = a003(:)
-
-!----------------------------------------------------------------------
-!     o(1d) reactions
-!----------------------------------------------------------------------
-
-!---  b001: o(1d) + co2  -> o + co2
-
-!     jpl 2006
-
-      b001(:) = 7.5e-11*exp(115./t(:))
-   
+ireact = 1
+
+! Reaction from monoreact file are implemented first
+do while(nb_phot<nb_phot_max-nphot_hard_coding)
+
+  if (rtype(ireact)/=0) then     ! skip photolysis reactions
+    ! get right coefficient rate function
+    if (rtype(ireact)==1) then
+      nb_pfunc1 = nb_pfunc1 + 1
+      if (third_body(ireact)==0) then            !! third_body check
+        ratec = pfunc1(nlayer,t,dens,pfunc1_param(nb_pfunc1))
+      else
+        ratec = pfunc1(nlayer,t,c(:,third_body(ireact)),pfunc1_param(nb_pfunc1))
+      end if
+    else if (rtype(ireact)==2) then
+      nb_pfunc2 = nb_pfunc2 + 1
+      if (third_body(ireact)==0) then            !! third_body check
+        ratec = pfunc2(nlayer,t,dens,pfunc2_param(nb_pfunc2))
+      else
+        ratec = pfunc2(nlayer,t,c(:,third_body(ireact)),pfunc2_param(nb_pfunc2))
+      end if
+    else if (rtype(ireact)==3) then
+      nb_pfunc3 = nb_pfunc3 + 1
+      if (third_body(ireact)==0) then            !! third_body check
+        ratec = pfunc3(nlayer,t,dens,pfunc3_param(nb_pfunc3))
+      else
+        ratec = pfunc3(nlayer,t,c(:,third_body(ireact)),pfunc3_param(nb_pfunc3))
+      end if
+    else
+      print*, 'Error in reactionrates: wrong index coefficient rate vphot'
+      print*, 'rtype(ireact) = ',rtype(ireact)
+      print*, 'It should be 1 or 2 '
+      print*, 'Please check the reaction ',ireact
+      if (ireact>nreact) print*, 'Please check the reaction count into the code beacause ireact > nreact is not possible'
+      stop
+    end if
+
+    ! fill the right type index
+    nb_phot = nb_phot + 1
+    v_phot(:,nb_phot) = ratec(:)
+    if (three_prod(ireact)) then             ! three_prod check
       nb_phot = nb_phot + 1
-      v_phot(:,nb_phot) = b001(:)*co2(:)
-
-!---  b002: o(1d) + h2o  -> oh + oh
-
-!     jpl 2006
- 
-      b002(:) = 1.63e-10*exp(60./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = b002(:)
-
-!---  b003: o(1d) + h2  -> oh + h
-
-!     jpl 2011
-
-      b003(:) = 1.2e-10
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = b003(:)
-
-!---  b004: o(1d) + o2  -> o + o2
-
-!     jpl 2006
-
-      b004(:) = 3.3e-11*exp(55./t(:))
-
-      nb_phot = nb_phot + 1
-      v_phot(:,nb_phot) = b004(:)*o2(:)
-    
-!---  b005: o(1d) + o3  -> o2 + o2
-
-!     jpl 2003
-
-      b005(:) = 1.2e-10
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = b005(:)
-    
-!---  b006: o(1d) + o3  -> o2 + o + o
-
-!     jpl 2003
-
-      b006(:) = 1.2e-10
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = b006(:)
-    
-!---  b007: o(1d) + ch4 -> ch3 + oh
-
-!     jpl 2003
-
-      b007(:) = 1.5e-10*0.75
-
-!---  b008: o(1d) + ch4 -> ch3o + h
-
-!     jpl 2003
-
-      b008(:) = 1.5e-10*0.20
-!
-!---  b009: o(1d) + ch4 -> ch2o + h2
-
-!     jpl 2003
-
-      b009(:) = 1.5e-10*0.05
-
-!----------------------------------------------------------------------
-!     hydrogen reactions
-!----------------------------------------------------------------------
-
-!---  c001: o + ho2 -> oh + o2
-
-!     jpl 2003
-
-      c001(:) = 3.0e-11*exp(200./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c001(:)
-
-!---  c002: o + oh -> o2 + h
-
-!     jpl 2011
-
-      c002(:) = 1.8e-11*exp(180./t(:))
-
-!     robertson and smith, j. chem. phys. a 110, 6673, 2006
-
-!     c002(:) = 11.2e-11*t(:)**(-0.32)*exp(177./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c002(:)
-
-!---  c003: h + o3 -> oh + o2
-
-!     jpl 2003
-
-      c003(:) = 1.4e-10*exp(-470./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c003(:)
-
-!---  c004: h + ho2 -> oh + oh
-
-!     jpl 2006
-
-      c004(:) = 7.2e-11
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c004(:)
-
-!---  c005: h + ho2 -> h2 + o2
-
-!     jpl 2006
-
-      c005(:) = 6.9e-12
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c005(:)
-
-!---  c006: h + ho2 -> h2o + o
-
-!     jpl 2006
-
-      c006(:) = 1.6e-12
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c006(:)
-
-!---  c007: oh + ho2 -> h2o + o2
-
-!     jpl 2003
-
-!     canty et al., grl, 2006 suggest to increase this rate
-!     by 20%. not done here.
-
-      c007(:) = 4.8e-11*exp(250./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c007(:)
-
-!---  c008: ho2 + ho2 -> h2o2 + o2
-
-!     jpl 2006
-
-!     c008(:) = 3.5e-13*exp(430./t(:))
-
-!     christensen et al., grl, 13, 2002
-
-      c008(:) = 1.5e-12*exp(19./t(:))
-
-      nb_reaction_3 = nb_reaction_3 + 1
-      v_3(:,nb_reaction_3) = c008(:)
-
-!---  c009: oh + h2o2 -> h2o + ho2
-
-!     jpl 2006
-
-      c009(:) = 1.8e-12
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c009(:)
-
-!---  c010: oh + h2 -> h2o + h
-
-!     jpl 2006
-
-      c010(:) = 2.8e-12*exp(-1800./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c010(:)
-
-!---  c011: h + o2 + co2 -> ho2 + co2
-
-!     jpl 2011
-
-      do ilev = 1,lswitch-1
-         ak0 = 2.5*4.4e-32*(t(ilev)/300.)**(-1.3)
-         ak1 = 7.5e-11*(t(ilev)/300.)**(0.2)
-
-         rate = (ak0*dens(ilev))/(1. + ak0*dens(ilev)/ak1)
-         xpo = 1./(1. + alog10((ak0*dens(ilev))/ak1)**2)
-         c011(ilev) = rate*0.6**xpo
-      end do
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c011(:)
-
-!---  c012: o + h2o2 -> oh + ho2
-
-!     jpl 2003
-
-      c012(:) = 1.4e-12*exp(-2000./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c012(:)
-
-!---  c013: oh + oh -> h2o + o
-
-!     jpl 2006
-
-      c013(:) = 1.8e-12
-
-      nb_reaction_3 = nb_reaction_3 + 1
-      v_3(:,nb_reaction_3) = c013(:)
-
-!---  c014: oh + o3 -> ho2 + o2
-
-!     jpl 2003
-
-      c014(:) = 1.7e-12*exp(-940./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c014(:)
-
-!---  c015: ho2 + o3 -> oh + o2 + o2
-
-!     jpl 2003
-
-      c015(:) = 1.0e-14*exp(-490./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = c015(:)
-
-!---  c016: ho2 + ho2 + co2 -> h2o2 + o2 + co2
-
-!     jpl 2011
-
-      c016(:) = 2.5*2.1e-33*exp(920./t(:))*dens(:)
-
-      nb_reaction_3 = nb_reaction_3 + 1
-      v_3(:,nb_reaction_3) = c016(:)
-
-!---  c017: oh + oh + co2 -> h2o2 + co2
-
-!     jpl 2003
-
-      do ilev = 1,lswitch-1
-         ak0 = 2.5*6.9e-31*(t(ilev)/300.)**(-1.0)
-         ak1 = 2.6e-11*(t(ilev)/300.)**(0.0)
-
-         rate = (ak0*dens(ilev))/(1. + ak0*dens(ilev)/ak1)
-         xpo = 1./(1. + alog10((ak0*dens(ilev))/ak1)**2)
-         c017(ilev) = rate*0.6**xpo
-      end do
-
-      nb_reaction_3 = nb_reaction_3 + 1
-      v_3(:,nb_reaction_3) = c017(:)
-
-!---  c018: h + h + co2 -> h2 + co2
-
-!     baulch et al., 2005
-
-      c018(:) = 2.5*1.8e-30*(t(:)**(-1.0))*dens(:)
-
-      nb_reaction_3 = nb_reaction_3 + 1
-      v_3(:,nb_reaction_3) = c018(:)
-
-!----------------------------------------------------------------------
-!     nitrogen reactions
-!----------------------------------------------------------------------
-
-!---  d001: no2 + o -> no + o2
-
-!     jpl 2006
-
-      d001(:) = 5.1e-12*exp(210./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = d001(:)
-
-!---  d002: no + o3 -> no2 + o2
-
-!     jpl 2006
-
-      d002(:) = 3.0e-12*exp(-1500./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = d002(:)
-
-!---  d003: no + ho2 -> no2 + oh
-
-!     jpl 2011
-
-      d003(:) = 3.3e-12*exp(270./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = d003(:)
-
-!---  d004: n + no -> n2 + o
-
-!     jpl 2011
-
-      d004(:) = 2.1e-11*exp(100./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = d004(:)
-
-!---  d005: n + o2 -> no + o
-
-!     jpl 2011
-
-      d005(:) = 1.5e-11*exp(-3600./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = d005(:)
-
-!---  d006: no2 + h -> no + oh
-
-!     jpl 2011
-
-      d006(:) = 4.0e-10*exp(-340./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = d006(:)
-
-!---  d007: n + o -> no
- 
-      d007(:) = 2.8e-17*(300./t(:))**0.5
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = d007(:)
-
-!---  d008: n + ho2 -> no + oh
-
-!     brune et al., j. chem. phys., 87, 1983 
-
-      d008(:) = 2.19e-11
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = d008(:)
-
-!---  d009: n + oh -> no + h
-
-!     atkinson et al., j. phys. chem. ref. data, 18, 881, 1989 
-
-      d009(:) = 3.8e-11*exp(85./t(:))
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = d009(:)
-
-!----------------------------------------------------------------------
-!     carbon reactions
-!----------------------------------------------------------------------
-
-!---  e001: oh + co -> co2 + h
-
-!     jpl 2003
-
-!     e001(:) = 1.5e-13*(1 + 0.6*press(:)/1013.)
-
-!     mccabe et al., grl, 28, 3135, 2001
-
-!     e001(:) = 1.57e-13 + 3.54e-33*dens(:)
-
-!     jpl 2006
-
-!     ak0 = 1.5e-13*(t(:)/300.)**(0.6)
-!     ak1 = 2.1e-9*(t(:)/300.)**(6.1)
-!     rate1 = ak0/(1. + ak0/(ak1/dens(:)))
-!     xpo1 = 1./(1. + alog10(ak0/(ak1/dens(:)))**2)
-
-!     ak0 = 5.9e-33*(t(:)/300.)**(-1.4)
-!     ak1 = 1.1e-12*(t(:)/300.)**(1.3)
-!     rate2 = (ak0*dens(:))/(1. + ak0*dens(:)/ak1)
-!     xpo2 = 1./(1. + alog10((ak0*dens(:))/ak1)**2)
-
-!     e001(:) = rate1*0.6**xpo1 + rate2*0.6**xpo2
-
-!     joshi et al., 2006
-
-      do ilev = 1,lswitch-1
-         k1a0 = 1.34*2.5*dens(ilev)                                  &
-               *1/(1/(3.62e-26*t(ilev)**(-2.739)*exp(-20./t(ilev)))  &
-               + 1/(6.48e-33*t(ilev)**(0.14)*exp(-57./t(ilev))))     ! typo in paper corrected
-         k1b0 = 1.17e-19*t(ilev)**(2.053)*exp(139./t(ilev))          &
-              + 9.56e-12*t(ilev)**(-0.664)*exp(-167./t(ilev))
-         k1ainf = 1.52e-17*t(ilev)**(1.858)*exp(28.8/t(ilev))        &
-                + 4.78e-8*t(ilev)**(-1.851)*exp(-318./t(ilev))
-         x = k1a0/(k1ainf - k1b0)
-         y = k1b0/(k1ainf - k1b0)
-         fc = 0.628*exp(-1223./t(ilev)) + (1. - 0.628)*exp(-39./t(ilev))  &
-            + exp(-t(ilev)/255.)
-         fx = fc**(1./(1. + (alog(x))**2))                           ! typo in paper corrected
-         k1a = k1a0*((1. + y)/(1. + x))*fx
-         k1b = k1b0*(1./(1.+x))*fx
-
-         e001(ilev) = k1a + k1b
-      end do
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = e001(:)
-
-!---  e002: o + co + m -> co2 + m
-
-!     tsang and hampson, 1986.
-
-      e002(:) = 2.5*6.5e-33*exp(-2184./t(:))*dens(:)
-
-      nb_reaction_4 = nb_reaction_4 + 1
-      v_4(:,nb_reaction_4) = e002(:)
-
-!----------------------------------------------------------------------
-!     heterogeneous chemistry 
-!----------------------------------------------------------------------
-
-      if (hetero_ice) then
-
-!        k = (surface*v*gamma)/4 (s-1)
-!        v = 100*sqrt(8rt/(pi*m))  (cm s-1)
- 
-!---     h001: ho2 + ice -> products
- 
-!        cooper and abbatt, 1996: gamma = 0.025
-      
-         gam = 0.025
-         h001(:) = surfice1d(:)       &
-                   *100.*sqrt(8.*8.31*t(:)/(33.e-3*pi))*gam/4.
- 
-!        h002: oh + ice -> products
- 
-!        cooper and abbatt, 1996: gamma = 0.03
- 
-         gam = 0.03
-         h002(:) = surfice1d(:)       &
-                   *100.*sqrt(8.*8.31*t(:)/(17.e-3*pi))*gam/4.
-
-!---     h003: h2o2 + ice -> products
- 
-!        gamma = 0.    test value
- 
-         gam = 0.
-         h003(:) = surfice1d(:)       &
-                   *100.*sqrt(8.*8.31*t(:)/(34.e-3*pi))*gam/4.
-      else
-         h001(:) = 0.
-         h002(:) = 0.
-         h003(:) = 0.
-      end if
-
-      nb_phot = nb_phot + 1
-      v_phot(:,nb_phot) = h001(:)
-
-      nb_phot = nb_phot + 1
-      v_phot(:,nb_phot) = h002(:)
-
-      nb_phot = nb_phot + 1
-      v_phot(:,nb_phot) = h003(:)
-
-      if (hetero_dust) then
- 
-!---     h004: ho2 + dust -> products
- 
-!        jacob, 2000: gamma = 0.2
-!        see dereus et al., atm. chem. phys., 2005
- 
-         gam = 0.2
-         h004(:) = surfdust1d(:)  &
-                   *100.*sqrt(8.*8.31*t(:)/(33.e-3*pi))*gam/4.
- 
-!---     h005: h2o2 + dust -> products
- 
-!        gamma = 5.e-4
-!        see dereus et al., atm. chem. phys., 2005
- 
-         gam = 5.e-4
-         h005(:) = surfdust1d(:)  &
-                   *100.*sqrt(8.*8.31*t(:)/(34.e-3*pi))*gam/4.
-      else
-         h004(:) = 0.
-         h005(:) = 0.
-      end if
- 
-      nb_phot = nb_phot + 1
-      v_phot(:,nb_phot) = h004(:)
-
-      nb_phot = nb_phot + 1
-      v_phot(:,nb_phot) = h005(:)
+      v_phot(:,nb_phot) = ratec(:)
+    end if
+  else
+    nb_hv = nb_hv + 1
+  end if
+
+  ireact = ireact + 1
+
+end do
+
+! Reaction from bimolreact file are implemented secondly
+do while(nb_reaction_4<nb_reaction_4_max-n4_hard_coding)
+
+  ! get right coefficient rate function
+  if (rtype(ireact)==1) then
+    nb_pfunc1 = nb_pfunc1 + 1
+    if (third_body(ireact)==0) then            !! third_body check
+      ratec = pfunc1(nlayer,t,dens,pfunc1_param(nb_pfunc1))
+    else
+      ratec = pfunc1(nlayer,t,c(:,third_body(ireact)),pfunc1_param(nb_pfunc1))
+    end if
+  else if (rtype(ireact)==2) then
+    nb_pfunc2 = nb_pfunc2 + 1
+    if (third_body(ireact)==0) then            !! third_body check
+      ratec = pfunc2(nlayer,t,dens,pfunc2_param(nb_pfunc2))
+    else
+      ratec = pfunc2(nlayer,t,c(:,third_body(ireact)),pfunc2_param(nb_pfunc2))
+    end if
+  else if (rtype(ireact)==3) then
+    nb_pfunc3 = nb_pfunc3 + 1
+    if (third_body(ireact)==0) then            !! third_body check
+      ratec = pfunc3(nlayer,t,dens,pfunc3_param(nb_pfunc3))
+    else
+      ratec = pfunc3(nlayer,t,c(:,third_body(ireact)),pfunc3_param(nb_pfunc3))
+    end if
+  else
+    print*, 'Error in reactionrates: wrong index coefficient rate v4'
+    print*, 'rtype(ireact) = ',rtype(ireact)
+    print*, 'It should be 1 or 2 '
+    print*, 'Please check the reaction ',ireact-nb_phot_max
+    if (ireact>nreact) print*, 'Please check the reaction count into the code beacause ireact > nreact is not possible'
+    stop
+  end if
+
+  ! fill the right type index
+  nb_reaction_4 = nb_reaction_4 + 1
+  v_4(:,nb_reaction_4) = ratec(:)
+  if (three_prod(ireact)) then             ! three_prod check
+    nb_reaction_4 = nb_reaction_4 + 1
+    v_4(:,nb_reaction_4) = ratec(:)
+  end if
+
+  ireact = ireact + 1
+
+end do
+
+! Reaction from quadrareact file are implemented thirdly
+do while(nb_reaction_3<nb_reaction_3_max-n3_hard_coding)
+
+  ! get right coefficient rate function
+  if (rtype(ireact)==1) then
+    nb_pfunc1 = nb_pfunc1 + 1
+    if (third_body(ireact)==0) then            !! third_body check
+      ratec = pfunc1(nlayer,t,dens,pfunc1_param(nb_pfunc1))
+    else
+      ratec = pfunc1(nlayer,t,c(:,third_body(ireact)),pfunc1_param(nb_pfunc1))
+    end if
+  else if (rtype(ireact)==2) then
+    nb_pfunc2 = nb_pfunc2 + 1
+    if (third_body(ireact)==0) then            !! third_body check
+      ratec = pfunc2(nlayer,t,dens,pfunc2_param(nb_pfunc2))
+    else
+      ratec = pfunc2(nlayer,t,c(:,third_body(ireact)),pfunc2_param(nb_pfunc2))
+    end if
+  else if (rtype(ireact)==3) then
+    nb_pfunc3 = nb_pfunc3 + 1
+    if (third_body(ireact)==0) then            !! third_body check
+      ratec = pfunc3(nlayer,t,dens,pfunc3_param(nb_pfunc3))
+    else
+      ratec = pfunc3(nlayer,t,c(:,third_body(ireact)),pfunc3_param(nb_pfunc3))
+    end if
+  else
+    print*, 'Error in reactionrates: wrong index coefficient rate v3'
+    print*, 'rtype(ireact) = ',rtype(ireact)
+    print*, 'It should be 1 or 2 '
+    print*, 'Please check the reaction ',ireact-nb_phot_max-nb_reaction_4_max
+    if (ireact>nreact) print*, 'Please check the reaction count into the code beacause ireact > nreact is not possible'
+    stop
+  end if
+
+  ! fill the right type index
+  nb_reaction_3 = nb_reaction_3 + 1
+  v_3(:,nb_reaction_3) = ratec(:)
+  if (three_prod(ireact)) then             ! three_prod check
+    nb_reaction_3 = nb_reaction_3 + 1
+    v_3(:,nb_reaction_3) = ratec(:)
+  end if
+
+  ireact = ireact + 1
+
+end do
+
+call reactionrates_HC(nlayer,nesp,dens,t,press,zmmean,sza,c,v_phot,v_4,v_3,nb_phot,nb_reaction_4,nb_reaction_3)
+
+!===========================================================
+!  check dimensions 
+!===========================================================
+
+if (firstcall) then
+ ireact = ireact-1
+ if (ireact /= nreact) print*, 'wrong dimensions in reactionrates : number of reaction should be ', nreact,' and not ', ireact
+ if ((nb_phot /= nb_phot_max)             .or.  &
+     (nb_reaction_3 /= nb_reaction_3_max) .or.  &
+     (nb_reaction_4 /= nb_reaction_4_max)) then
+    print*, 'nb_phot       = ', nb_phot
+    print*, 'nb_reaction_4 = ', nb_reaction_4
+    print*, 'nb_reaction_3 = ', nb_reaction_3
+    print*, 'wrong dimensions in reactionrates' 
+    print*, 'nb_phot_max       = ', nb_phot_max
+    print*, 'nb_reaction_4_max = ', nb_reaction_4_max
+    print*, 'nb_reaction_3_max = ', nb_reaction_3_max
+    print*, '------ hard coding reaction ------'
+    print*, 'nphot_hard_coding = ', nphot_hard_coding
+    print*, 'n4_hard_coding    = ', n4_hard_coding
+    print*, 'n3_hard_coding    = ', n3_hard_coding
+    stop
+ end if
+ if ((nb_hv /= nb_hv_max)         .or.  &
+     (nb_pfunc1 /= nb_pfunc1_max) .or.  &
+     (nb_pfunc2 /= nb_pfunc2_max) .or.  &
+     (nb_pfunc3 /= nb_pfunc3_max)) then
+    print*, 'nb_hv         = ', nb_hv
+    print*, 'nb_pfunc1     = ', nb_pfunc1
+    print*, 'nb_pfunc2     = ', nb_pfunc2
+    print*, 'nb_pfunc3     = ', nb_pfunc3
+    print*, 'wrong dimensions in reactionrates'
+    print*, 'nb_hv_max     = ', nb_hv_max
+    print*, 'nb_pfunc1_max = ', nb_pfunc1_max
+    print*, 'nb_pfunc2_max = ', nb_pfunc2_max
+    print*, 'nb_pfunc3_max = ', nb_pfunc3_max
+    stop
+ end if
+firstcall = .false.
+end if 
 
 end subroutine reactionrates
@@ -1013,8 +735,7 @@
 
 use types_asis
+use chimiedata_h
 
 implicit none
-
-#include "chimiedata.h"
 
 ! input
@@ -1122,7 +843,5 @@
 !================================================================
 
- subroutine indice(i_co2, i_co, i_o, i_o1d, i_o2, i_o3, i_h,       &
-                   i_h2, i_oh, i_ho2, i_h2o2, i_h2o,               &
-                   i_n, i_n2d, i_no, i_no2, i_n2)
+ subroutine indice(nreact,rtype,third_body,three_prod)
 
 !================================================================
